package xyz.tbvns.core;

import lombok.extern.slf4j.Slf4j;
import oshi.SystemInfo;
import oshi.software.os.OperatingSystem;
import oshi.software.os.linux.LinuxOperatingSystem;
import oshi.software.os.mac.MacOperatingSystem;
import oshi.software.os.windows.WindowsOperatingSystem;

@Slf4j
public class FilesLocations {
    public static final String windowGeometryDashFolder = System.getenv("LOCALAPPDATA") + "/GeometryDash/";
    public static final String linuxGeometryDashFolder = System.getProperty("user.home") + "/.local/share/Steam/steamapps/compatdata/322170/pfx/drive_c/users/steamuser/AppData/Local/GeometryDash/";
    public static final String macGeometryDashFolder = System.getProperty("user.home") + "/Library/Application Support/GeometryDash";

    public static String getGeometryDashFolder() {
        SystemInfo si = new SystemInfo();
        OperatingSystem os = si.getOperatingSystem();
        if (os instanceof WindowsOperatingSystem) {
            return windowGeometryDashFolder;
        } else if (os instanceof LinuxOperatingSystem) {
            return linuxGeometryDashFolder;
        } else if (os instanceof MacOperatingSystem) {
            return macGeometryDashFolder;
        }
        throw new RuntimeException("Unsupported operating system !");
    }
}
