package xyz.tbvns.core;

import javafx.application.Platform;
import javafx.geometry.Pos;
import javafx.scene.Scene;
import javafx.scene.control.Label;
import javafx.scene.control.ProgressBar;
import javafx.scene.layout.FlowPane;
import javafx.scene.layout.GridPane;
import javafx.stage.Stage;
import lombok.Getter;

public class UIProgressBar {
    @Getter private ProgressBar progressBar;
    @Getter private Stage stage;
    public void open(String title) {
        Platform.runLater(() -> {
            openNow(title);
        });
    }

    public void openNow(String title) {
        stage = new Stage();
        stage.setWidth(200);
        stage.setHeight(80);
        stage.setAlwaysOnTop(true);
        stage.setResizable(false);

        FlowPane pane = new FlowPane();
        pane.setPrefWidth(stage.getWidth());
        pane.setPrefHeight(stage.getHeight());
        pane.setAlignment(Pos.CENTER);

        Label label = new Label(title);
        label.setPrefWidth(pane.getPrefWidth() - 20);
        pane.getChildren().add(label);

        progressBar = new ProgressBar();
        progressBar.setProgress(0);
        progressBar.setPrefWidth(pane.getPrefWidth() - 20);
        pane.getChildren().add(progressBar);

        Scene scene = new Scene(pane);
        stage.setScene(scene);
        stage.show();
    }

    public void updateBar(double value) {
        Platform.runLater(() -> {
            progressBar.setProgress(value);
        });
    }

    public void close() {
        new Thread(() -> {
            try {
                Thread.sleep(100);
            } catch (InterruptedException e) {
                throw new RuntimeException(e);
            }
            Platform.runLater(() -> {
                stage.close();
            });
        }).start();
    }
}
