package xyz.tbvns.ui.LevelEditor;

import javafx.scene.Scene;
import javafx.scene.control.*;
import javafx.scene.layout.FlowPane;
import javafx.scene.layout.Pane;
import javafx.stage.Stage;
import org.reflections.Reflections;
import xyz.tbvns.core.Objects.Level;
import xyz.tbvns.core.UIProgressBar;
import xyz.tbvns.ui.Main;

import java.util.Set;

public class MainWindow {
    public static Level level;
    public static Scene scene;
    public static Stage stage;
    public static void open(Stage stage, Level level) {
        MainWindow.level = level;
        MainWindow.stage = stage;
        scene = new Scene(pane(level));
        stage.setScene(scene);
        stage.setTitle("PowerGD: Editing " + level.getName() + " by " + level.getCreator());
        Main.setUpResizeEditMenu(scene);
        stage.show();
        stage.setHeight(500);
        stage.setWidth(800);
    }

    public static Pane pane(Level level) {
        FlowPane pane = new FlowPane();
        pane.getChildren().add(toolBar(level));
        pane.getChildren().add(tabPane());
        return pane;
    }

    public static TabPane tabPane;
    public static TabPane tabPane() {
        TabPane pane = new TabPane();
        tabPane = pane;

        //Usage of reflection to generate tabs
        Reflections reflections = new Reflections("xyz.tbvns.ui.LevelEditor.tabs");
        Set<Class<? extends FXTab>> tabs = reflections.getSubTypesOf(FXTab.class);
        for (Class<? extends FXTab> tab : tabs) {
             try {
                 FXTab tabInstance = tab.getConstructor().newInstance();
                 System.out.println(tabInstance.getClass());
                 Tab usableTab = new Tab(tabInstance.getTitle(), tabInstance.getPane(level));
                 usableTab.setClosable(false);
                 pane.getTabs().add(usableTab);
                 tabInstance.setupResize(pane);
             } catch (Exception e) {
                 throw new RuntimeException(e);
             }
        }

        tabPane.widthProperty().addListener((observableValue, number, t1) -> {
            for (Tab tab : tabPane.getTabs()) {
                tab.getContent().prefWidth(t1.floatValue());
                tab.getContent().setLayoutX(t1.floatValue());
            }
        });

        tabPane.heightProperty().addListener((observableValue, number, t1) -> {
            for (Tab tab : tabPane.getTabs()) {
                tab.getContent().prefHeight(t1.floatValue());
                tab.getContent().setLayoutY(t1.floatValue());
            }
        });

        return pane;
    }

    public static MenuBar menuBar;
    public static MenuBar toolBar(Level level) {
        MenuBar menuBar = new MenuBar();
        MainWindow.menuBar = menuBar;

        Reflections reflections = new Reflections("xyz.tbvns.ui.LevelEditor.menus");
        Set<Class<? extends FXMenu>> menus = reflections.getSubTypesOf(FXMenu.class);
        for (Class<? extends FXMenu> menu : menus) {
            try {
                FXMenu fxMenu = menu.getConstructor().newInstance();
                System.out.println(fxMenu.getClass());
                menuBar.getMenus().add(fxMenu.getMenu(level, menuBar));
            } catch (Exception e) {
                throw new RuntimeException(e);
            }
        }

        return menuBar;
    }
}
