package xyz.tbvns.ui.LevelEditor;

import javafx.scene.Node;
import javafx.stage.FileChooser;
import xyz.tbvns.core.DataManager;
import xyz.tbvns.core.Decoder;
import xyz.tbvns.core.Objects.Level;
import xyz.tbvns.core.UIProgressBar;

import java.io.File;
import java.io.IOException;

public class SaveManager {
    public static void export(Node node, Level level) {
        FileChooser chooser = new FileChooser();
        chooser.setTitle("Export " + level.getName() + ".gmd");
        chooser.setInitialFileName(level.getName() + ".gmd");
        File file = chooser.showSaveDialog(node.getScene().getWindow());
        if (file != null) {
            try {
                UIProgressBar progressBar = new UIProgressBar();
                progressBar.openNow("Exporting level...");
                new Thread(() -> {
                    try {
                        Decoder.exportGMD(level, file.getPath(), progressBar, 1);
                        progressBar.close();
                    } catch (Exception e) {
                        throw new RuntimeException(e);
                    }
                }).start();
            } catch (Exception e) {
                throw new RuntimeException(e);
            }
        }
    }

    public static void save(Level level) {
        UIProgressBar progressBar = new UIProgressBar();
        progressBar.openNow("Saving level...");
        new Thread(() -> {
            try {
                DataManager.saveLevel(level, progressBar, 1);
            } catch (IOException e) {
                throw new RuntimeException(e);
            }
            progressBar.updateBar(1);
            progressBar.close();
        }).start();
    }
}
