package xyz.tbvns.ui.LevelEditor.menus;

import javafx.scene.Node;
import javafx.scene.Scene;
import javafx.scene.control.Menu;
import javafx.scene.control.MenuItem;
import xyz.tbvns.core.Objects.Level;
import xyz.tbvns.ui.LevelEditor.FXMenu;
import xyz.tbvns.ui.LevelEditor.MainWindow;
import xyz.tbvns.ui.LevelEditor.SaveManager;
import xyz.tbvns.ui.LevelSelectScreen;
import xyz.tbvns.ui.Main;

public class EditFilesMenu implements FXMenu {
    @Override
    public Menu getMenu(Level level, Node node) {
        Menu menu = new Menu("Files");

        MenuItem save = new MenuItem("Save");
        MenuItem close = new MenuItem("Close");

        Menu export = new Menu("Export");
        MenuItem exportGMD = new MenuItem("GDShare (.gmd)");
        MenuItem exportWSLiveEditor = new MenuItem("WSLiveEditor");
        exportWSLiveEditor.setDisable(true);
        export.getItems().addAll(exportGMD, exportWSLiveEditor);

        menu.getItems().addAll(save, export, close);

        save.setOnAction(actionEvent -> {
            SaveManager.save(level);
        });

        exportGMD.setOnAction(actionEvent -> {
            SaveManager.export(node, level);
        });

        close.setOnAction(actionEvent -> {
            Scene scene = new Scene(LevelSelectScreen.pane());
            Main.setUpResizeSelectMenu(scene);
            MainWindow.stage.hide();
            MainWindow.stage.setScene(scene);
            MainWindow.stage.show();
        });

        return menu;
    }
}
