package xyz.tbvns.ui.LevelEditor.tabs;

import javafx.geometry.Pos;
import javafx.scene.Node;
import javafx.scene.control.*;
import javafx.scene.layout.FlowPane;
import javafx.scene.layout.GridPane;
import javafx.scene.layout.Pane;
import javafx.stage.FileChooser;
import lombok.extern.slf4j.Slf4j;
import xyz.tbvns.core.DataManager;
import xyz.tbvns.core.Decoder;
import xyz.tbvns.core.Objects.Level;
import xyz.tbvns.core.UIProgressBar;
import xyz.tbvns.ui.LevelEditor.FXTab;

import java.io.File;

@Slf4j
public class EditMetadata implements FXTab {
    GridPane pane;
    Label title;
    Label creator;
    Label desc;
    TextField areaTitle;
    TextField areaCreator;
    TextArea areaDesc;
    @Override
    public Pane getPane(Level level) {
        pane = new GridPane();
        pane.setAlignment(Pos.TOP_LEFT);
        title = new Label("Title:");
        creator = new Label("Creator:");
        desc = new Label("Description:");

        areaTitle = new TextField(level.getName());
        areaCreator = new TextField(level.getCreator());
        areaDesc = new TextArea(level.getDescription());
        areaDesc.setPrefRowCount(2);
        if (level.getDescriptionLine() == 0) {
            areaDesc.setDisable(true);
            areaDesc.setText("no description found !");
        }
        Button update = new Button("Update");
        update.setOnMouseClicked(mouseEvent -> {
            level.setName(areaTitle.getText());
            level.setCreator(areaCreator.getText());
            level.setDescription(areaDesc.getText());
        });

//        pane.getChildren().addAll(title, areaTitle, creator, areaCreator);
        pane.add(title, 1, 1);
        pane.add(areaTitle, 1, 2);
        pane.add(creator, 1, 3);
        pane.add(areaCreator, 1, 4);
        pane.add(desc, 1, 5);
        pane.add(areaDesc, 1, 6);
        pane.add(update, 1, 7);

        return new FlowPane(pane);
    }

    @Override
    public String getTitle() {
        return "Information";
    }

    @Override
    public void setupResize(TabPane parent) {
        parent.widthProperty().addListener((observableValue, number, t1) -> {
            if (t1.floatValue() <= 200) {
                title.setPrefWidth(t1.floatValue());
                areaTitle.setPrefWidth(t1.floatValue());
                creator.setPrefWidth(t1.floatValue());
                areaCreator.setPrefWidth(t1.floatValue());
            } else {
                title.setPrefWidth(200);
                areaTitle.setPrefWidth(200);
                creator.setPrefWidth(200);
                areaCreator.setPrefWidth(200);
            }
        });

        for (Node child : pane.getChildren()) {
            child.prefHeight(20);
        }
    }
}
